var phyTime;
var  table;
var laydate;
var personIdArray = [];
layui.use(['table', 'layer', 'laydate', 'jquery', 'form'], function () {
    table = layui.table;
    laydate = layui.laydate;
    let form = layui.form;
    //渲染table
    table.render({
        elem: '#demo'
        , url: ctxPath + '/Careerdispos/getMsgContent' //数据接口
        , method: 'post' //方式默认是get
        , toolbar: 'default' //开启工具栏，此处显示默认图标，可以自定义模板，详见文档
        , where: {"higherJob":"0"} //post请求必须加where ，post请求需要的参数
        , cellMinWidth: 80
        , cols: [[ //表头
            {field: 'number', width:100, title: '序号', align: 'center', type: 'numbers'}
            , {field: 'startDate',align: 'center', title: '日期'}
            , {field: 'limitPerson',align: 'center', title: '上限人数'}
            , {field: 'hospital',    align: 'center', title: '预约医院'}

            , {fixed: 'right', title: '操作', width: 200, align: 'center', toolbar: '#toolsBar'}
        ]]
        ,done: function (res, curr, count) {
            let state = "";
            for (var i in res.data) {
                var item = res.data[i];
                /**
                 * 初始化数据表格赋值
                 */
                if (!isNull(item.reservationTime) ){
                    res.data[i]["LAY_CHECKED"] = false;
                    $('tr[data-index=' + i + '] input[type="checkbox"]').prop('disabled', true);
                    state = "1";// 隐藏表头全选判断状态
                    form.render();// 重新渲染一下
                }
                for (var j in personIdArray) {
                    if(personIdArray[j].personId === res.data[i].personId){
                        res.data[i]["LAY_CHECKED"] = true;
                        $('tr[data-index=' + i + '] input[type="checkbox"]').prop('checked', true);
                        $('tr[data-index=' + i + '] input[type="checkbox"]').next().addClass('layui-form-checked');
                    }
                }

            };
        }
        , id: 'menuTable'
        , page: true //开启分页
        , loading: true //数据加载中。。。
        , limits: [5, 10, 20]  //一页选择显示3,5或10条数据
        , limit: 10  //一页显示5条数据
        , response: {
            statusCode: 200 //规定成功的状态码，默认：0
        }, parseData: function (res) { //将原始数据解析成 table 组件所规定的数据，res为从url中get到的数据
            let result;
            if (res.data !== '' && res.data != null && res.data !== "null") {
                if (this.page.curr) {
                    result = res.data.slice(this.limit * (this.page.curr - 1), this.limit * this.page.curr);
                } else {
                    result = res.data.slice(0, this.limit);
                }
            }
            return {
                "code": res.code, //解析接口状态
                "msg": res.msg, //解析提示文本
                "count": res.count, //解析数据长度
                "data": result, //解析数据列表
            };
        },

        toolbar: "#toolbar"
    });

    // 行工具事件
    table.on('tool(test)', function (obj) {
        var data = obj.data //获得当前行数据
        var layEvent = obj.event; //获得 lay-event 对应的值
        var id = data.id
        if (layEvent === 'edit') {
            openForm(id,'修改');
        } else if (layEvent === 'del') {
            delHospital(id);
        }
    });
    table.on('checkbox(test)', function (obj) {
        // console.log(obj);
        //当前页面数据
        var thisPageData = table.cache.menuTable;//当前页面数据
        //one 单条数据 all全选
        var checkType = obj.type;
        //  true选择 false取消
        var isCheck = obj.checked;
        if(checkType === "one"){
            var personId = obj.data.personId;
            var personData = obj.data;
            if(isCheck){
                personIdArray.push(personData);

                personIdArray = personIdArray.filter(function (element, index, self) {
                    return self.indexOf(element) === index;
                });
            }else{
                personIdArray = personIdArray.filter(function(item) {
                    return item.personId !== personId;
                });
            }
        }else{
            if(isCheck){
                for (var i in thisPageData) {
                    var item = thisPageData[i];
                    /**
                     * 初始化数据表格赋值
                     */
                    if (!isNull(item.reservationTime) ){
                        item["LAY_CHECKED"] = false;
                        $('tr[data-index=' + i + '] input[type="checkbox"]').prop('disabled', true);
                        $('tr[data-index=' + i + '] input[type="checkbox"]').next().removeAttr('layui-form-checked');
                        form.render();// 重新渲染一下
                    }else{
                        personIdArray.push(item);
                    }

                };
                personIdArray = repeatArray(personIdArray);
                console.log("personIdArray="+JSON.stringify(personIdArray));
            }else{
                //thisPageData
                var itemArray = [];
                for (var i in thisPageData) {
                    var item = thisPageData[i];
                    var personId = item.personId;
                    for (var j in personIdArray) {
                        if(personId === personIdArray[j].personId){
                            itemArray.push(personIdArray[j])
                        }
                    }
                }
                personIdArray = personIdArray.filter(v => !itemArray.some((item) => item === v))
                personIdArray = repeatArray(personIdArray);

                console.log("personIdArray="+JSON.stringify(personIdArray))
            }
        }

    });

    //头监听事件 -- checkBox 选中行和选中条数
    table.on('toolbar(test)', function (obj) {
        // 获取当前表格被选中的记录对象，返回数据
        var checkStatus = table.checkStatus(obj.config.id);
        //获取事件名，执行对应的代码
        var eventName = obj.event;
        switch (eventName) {
            case "searchBt":
                phyTime = $("#phyTime").val();
                table.reload('menuTable', {
                    url: ctxPath + '/Careerdispos/getMsgContent'
                    , method: 'post' //方式默认是get
                    , page: true
                    , where: {
                        phyTime: phyTime
                    } //设定异步数据接口的额外参数
                });
                initTime();
                /**二次赋值-- 点击搜索按钮之后会进行一次刷新操作*/
                $("#phyTime").val(phyTime);
                break;

            case "addBtn":
                openForm("",'新增');
                break;
        }
    });
    initTime();
});

function initTime() {
    // 日期选择器
    laydate.render({
        elem: '#phyTime'
    });
}

/**
 * 修改功能
 */
function openForm(id,title){
    localStorage.setItem("id",id);
    layerOpenForm(title,"./careerdispositionFrom.html","60%","80%")
}


/**
 * 删除功能
 */
function delHospital(id) {
    layer.confirm('确定要删除吗？', {
        btn : [ '确定', '取消' ]
    }, function() {
        ajaxCommonMethods('/Careerdispos/delById',{'id': id},"删除成功","删除失败","1");
        layer.close(1);
    });
}